package com.oreilly.jent.servlets;

/**
 * In general, you may use the code in this book in your programs and 
 * documentation. You do not need to contact us for permission unless 
 * you're reproducing a significant portion of the code. For example, 
 * writing a program that uses several chunks of code from this book does 
 * not require permission. Selling or distributing a CD-ROM of examples 
 * from O'Reilly books does require permission. Answering a question by 
 * citing this book and quoting example code does not require permission. 
 * Incorporating a significant amount of example code from this book into 
 * your product's documentation does require permission.
 * 
 * We appreciate, but do not require, attribution. An attribution usually 
 * includes the title, author, publisher, and ISBN. For example: 
 * 
 *   "Java Enterprise in a Nutshell, Third Edition, 
 *    by Jim Farley and William Crawford 
 *    with Prakash Malani, John G. Norman, and Justin Gehtland. 
 *    Copyright 2006 O'Reilly Media, Inc., 0-596-10142-2."
 *  
 *  If you feel your use of code examples falls outside fair use or the 
 *  permission given above, feel free to contact us at 
 *  permissions@oreilly.com.
 */

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.PrintWriter;

import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

public class LifeCycleServlet extends HttpServlet {

  int timesAccessed;

  public void init(ServletConfig conf) throws ServletException {

    super.init(conf);

    // Get initial value
    try {
      timesAccessed = Integer.parseInt(getInitParameter("defaultStart"));
    }
    catch(NullPointerException e) {
      timesAccessed = 0;
    }
    catch(NumberFormatException e) {
      timesAccessed = 0;
    }

    // Try loading from the disk
    DataInputStream ds = null;
    try {
      File r = new File("./data/counter.dat");
      ds = new DataInputStream(new FileInputStream(r));
      timesAccessed = ds.readInt(  );
    }
    catch (FileNotFoundException e) {
      // Handle error
    }
    catch (IOException e) {
      // This should be logged
    }
    finally {
      if (ds != null)
         try {
             ds.close();
         } catch (IOException ignored) {}
    }
  }

  public void doGet(HttpServletRequest req, HttpServletResponse resp)
    throws ServletException, IOException {

    resp.setContentType("text/html");
    PrintWriter out = resp.getWriter(  );

    timesAccessed++;

    out.println("<html>");
    out.println("<head>");
    out.println("<title>Life Cycle Servlet</title>");
    out.println("</head><body>");

    out.println("I have been accessed " + timesAccessed + " time[s]");
    out.println("</body></html>");
  }

  public void destroy(  ) {

    // Write the Integer to a file
    File r = new File("./data/counter.dat");
    DataOutputStream dout = null;
    try {
      dout = new DataOutputStream(new FileOutputStream(r));
      dout.writeInt(timesAccessed);
    }
    catch(IOException e) {
      // This should be logged
    }
    finally {
      try { dout.close(  ); } catch (IOException ignored) {}
    }
  }
}
